// test2.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "../ArchiveManager/ArchiveManager.h"

#ifdef _DEBUG
#pragma comment(lib, "../Debug/ArchiveManager.lib")
#else
#pragma comment(lib, "../Release/ArchiveManager.lib")
#endif

static const WCHAR *archiveNames[] = {
	L"Unspported",
	L"zip",
	L"lzh",
	L"cab", 
	L"rar",
	L"iso",
};

void usage()
{
	puts("test2 [type] [target archive file]\n"
		 "[type] zip, lzh, cab, rar, iso\n"
		);
}

int _tmain(int argc, _TCHAR* argv[])
{
	int i, index = -1;
	HARCHIVE hArchive;

	_wsetlocale( LC_ALL, L"" );

	if (argc != 3) {
		usage();
		return -1;
	}

	// Search index
	for (i = 1; i < sizeof(archiveNames)/sizeof(archiveNames[0]); i++) {
		if (lstrcmpiW(archiveNames[i], argv[1]) == 0) {
			index = i;
		}
	}
	
	// Not found
	if (index == -1) {
		_tprintf(L"[%s] is not supported\n", argv[1]);
		return -1;
	}

	// Open
	hArchive = OpenArchiveAs(argv[2], index);
	if (hArchive == NULL) {
		if (GetAMLastError() == ERROR_UNSUPPORTED_TYPE) {
			_tprintf(L"Failed to be opened \"%s\" by [%s] format\n", argv[2], argv[1]);
		} else {
			_tprintf(L"Failed to open %s\n", argv[2]);
		}
		return -1;
	}

	_tprintf(L"OK: Open \"%s\" as [%s] format\n", argv[2], argv[1]);

	CloseArchive(hArchive);
	return 0;
}

